package net.minecraft.data.worldgen;

import net.minecraft.core.Holder;
import net.minecraft.core.Registry;
import net.minecraft.data.BuiltinRegistries;
import net.minecraft.resources.ResourceKey;
import net.minecraft.world.level.levelgen.Noises;
import net.minecraft.world.level.levelgen.synth.NormalNoise;

public class NoiseData {
   public static Holder<NormalNoise.NoiseParameters> bootstrap(Registry<NormalNoise.NoiseParameters> p_236476_) {
      registerBiomeNoises(p_236476_, 0, Noises.TEMPERATURE, Noises.VEGETATION, Noises.CONTINENTALNESS, Noises.EROSION);
      registerBiomeNoises(p_236476_, -2, Noises.TEMPERATURE_LARGE, Noises.VEGETATION_LARGE, Noises.CONTINENTALNESS_LARGE, Noises.EROSION_LARGE);
      register(p_236476_, Noises.RIDGE, -7, 1.0D, 2.0D, 1.0D, 0.0D, 0.0D, 0.0D);
      register(p_236476_, Noises.SHIFT, -3, 1.0D, 1.0D, 1.0D, 0.0D);
      register(p_236476_, Noises.AQUIFER_BARRIER, -3, 1.0D);
      register(p_236476_, Noises.AQUIFER_FLUID_LEVEL_FLOODEDNESS, -7, 1.0D);
      register(p_236476_, Noises.AQUIFER_LAVA, -1, 1.0D);
      register(p_236476_, Noises.AQUIFER_FLUID_LEVEL_SPREAD, -5, 1.0D);
      register(p_236476_, Noises.PILLAR, -7, 1.0D, 1.0D);
      register(p_236476_, Noises.PILLAR_RARENESS, -8, 1.0D);
      register(p_236476_, Noises.PILLAR_THICKNESS, -8, 1.0D);
      register(p_236476_, Noises.SPAGHETTI_2D, -7, 1.0D);
      register(p_236476_, Noises.SPAGHETTI_2D_ELEVATION, -8, 1.0D);
      register(p_236476_, Noises.SPAGHETTI_2D_MODULATOR, -11, 1.0D);
      register(p_236476_, Noises.SPAGHETTI_2D_THICKNESS, -11, 1.0D);
      register(p_236476_, Noises.SPAGHETTI_3D_1, -7, 1.0D);
      register(p_236476_, Noises.SPAGHETTI_3D_2, -7, 1.0D);
      register(p_236476_, Noises.SPAGHETTI_3D_RARITY, -11, 1.0D);
      register(p_236476_, Noises.SPAGHETTI_3D_THICKNESS, -8, 1.0D);
      register(p_236476_, Noises.SPAGHETTI_ROUGHNESS, -5, 1.0D);
      register(p_236476_, Noises.SPAGHETTI_ROUGHNESS_MODULATOR, -8, 1.0D);
      register(p_236476_, Noises.CAVE_ENTRANCE, -7, 0.4D, 0.5D, 1.0D);
      register(p_236476_, Noises.CAVE_LAYER, -8, 1.0D);
      register(p_236476_, Noises.CAVE_CHEESE, -8, 0.5D, 1.0D, 2.0D, 1.0D, 2.0D, 1.0D, 0.0D, 2.0D, 0.0D);
      register(p_236476_, Noises.ORE_VEININESS, -8, 1.0D);
      register(p_236476_, Noises.ORE_VEIN_A, -7, 1.0D);
      register(p_236476_, Noises.ORE_VEIN_B, -7, 1.0D);
      register(p_236476_, Noises.ORE_GAP, -5, 1.0D);
      register(p_236476_, Noises.NOODLE, -8, 1.0D);
      register(p_236476_, Noises.NOODLE_THICKNESS, -8, 1.0D);
      register(p_236476_, Noises.NOODLE_RIDGE_A, -7, 1.0D);
      register(p_236476_, Noises.NOODLE_RIDGE_B, -7, 1.0D);
      register(p_236476_, Noises.JAGGED, -16, 1.0D, 1.0D, 1.0D, 1.0D, 1.0D, 1.0D, 1.0D, 1.0D, 1.0D, 1.0D, 1.0D, 1.0D, 1.0D, 1.0D, 1.0D, 1.0D);
      register(p_236476_, Noises.SURFACE, -6, 1.0D, 1.0D, 1.0D);
      register(p_236476_, Noises.SURFACE_SECONDARY, -6, 1.0D, 1.0D, 0.0D, 1.0D);
      register(p_236476_, Noises.CLAY_BANDS_OFFSET, -8, 1.0D);
      register(p_236476_, Noises.BADLANDS_PILLAR, -2, 1.0D, 1.0D, 1.0D, 1.0D);
      register(p_236476_, Noises.BADLANDS_PILLAR_ROOF, -8, 1.0D);
      register(p_236476_, Noises.BADLANDS_SURFACE, -6, 1.0D, 1.0D, 1.0D);
      register(p_236476_, Noises.ICEBERG_PILLAR, -6, 1.0D, 1.0D, 1.0D, 1.0D);
      register(p_236476_, Noises.ICEBERG_PILLAR_ROOF, -3, 1.0D);
      register(p_236476_, Noises.ICEBERG_SURFACE, -6, 1.0D, 1.0D, 1.0D);
      register(p_236476_, Noises.SWAMP, -2, 1.0D);
      register(p_236476_, Noises.CALCITE, -9, 1.0D, 1.0D, 1.0D, 1.0D);
      register(p_236476_, Noises.GRAVEL, -8, 1.0D, 1.0D, 1.0D, 1.0D);
      register(p_236476_, Noises.POWDER_SNOW, -6, 1.0D, 1.0D, 1.0D, 1.0D);
      register(p_236476_, Noises.PACKED_ICE, -7, 1.0D, 1.0D, 1.0D, 1.0D);
      register(p_236476_, Noises.ICE, -4, 1.0D, 1.0D, 1.0D, 1.0D);
      register(p_236476_, Noises.SOUL_SAND_LAYER, -8, 1.0D, 1.0D, 1.0D, 1.0D, 0.0D, 0.0D, 0.0D, 0.0D, 0.013333333333333334D);
      register(p_236476_, Noises.GRAVEL_LAYER, -8, 1.0D, 1.0D, 1.0D, 1.0D, 0.0D, 0.0D, 0.0D, 0.0D, 0.013333333333333334D);
      register(p_236476_, Noises.PATCH, -5, 1.0D, 0.0D, 0.0D, 0.0D, 0.0D, 0.013333333333333334D);
      register(p_236476_, Noises.NETHERRACK, -3, 1.0D, 0.0D, 0.0D, 0.35D);
      register(p_236476_, Noises.NETHER_WART, -3, 1.0D, 0.0D, 0.0D, 0.9D);
      return register(p_236476_, Noises.NETHER_STATE_SELECTOR, -4, 1.0D);
   }

   private static void registerBiomeNoises(Registry<NormalNoise.NoiseParameters> p_236478_, int p_236479_, ResourceKey<NormalNoise.NoiseParameters> p_236480_, ResourceKey<NormalNoise.NoiseParameters> p_236481_, ResourceKey<NormalNoise.NoiseParameters> p_236482_, ResourceKey<NormalNoise.NoiseParameters> p_236483_) {
      register(p_236478_, p_236480_, -10 + p_236479_, 1.5D, 0.0D, 1.0D, 0.0D, 0.0D, 0.0D);
      register(p_236478_, p_236481_, -8 + p_236479_, 1.0D, 1.0D, 0.0D, 0.0D, 0.0D, 0.0D);
      register(p_236478_, p_236482_, -9 + p_236479_, 1.0D, 1.0D, 2.0D, 2.0D, 2.0D, 1.0D, 1.0D, 1.0D, 1.0D);
      register(p_236478_, p_236483_, -9 + p_236479_, 1.0D, 1.0D, 0.0D, 1.0D, 1.0D);
   }

   private static Holder<NormalNoise.NoiseParameters> register(Registry<NormalNoise.NoiseParameters> p_236485_, ResourceKey<NormalNoise.NoiseParameters> p_236486_, int p_236487_, double p_236488_, double... p_236489_) {
      return BuiltinRegistries.register(p_236485_, p_236486_, new NormalNoise.NoiseParameters(p_236487_, p_236488_, p_236489_));
   }
}