package net.minecraft.server.level;

import net.minecraft.Util;
import net.minecraft.core.SectionPos;
import net.minecraft.world.level.lighting.DynamicGraphMinFixedPoint;

public abstract class SectionTracker extends DynamicGraphMinFixedPoint<SectionPos> {
   protected SectionTracker(int p_8274_, int p_8275_, int p_8276_) {
      super(p_8274_, p_8275_, p_8276_);
   }

   protected boolean isSource(SectionPos p_8278_) {
      return p_8278_ == null;
   }

   protected void checkNeighborsAfterUpdate(SectionPos p_8280_, int p_8281_, boolean p_8282_) {
      for(int i = -1; i <= 1; ++i) {
         for(int j = -1; j <= 1; ++j) {
            for(int k = -1; k <= 1; ++k) {
            	SectionPos l = p_8280_.offset(i, j, k);
               if (l.equals(p_8280_)) {
                  this.checkNeighbor(p_8280_, l, p_8281_, p_8282_);
               }
            }
         }
      }

   }

   protected int getComputedLevel(SectionPos p_8284_, SectionPos p_8285_, int p_8286_) {
      int i = p_8286_;

      for(int j = -1; j <= 1; ++j) {
         for(int k = -1; k <= 1; ++k) {
            for(int l = -1; l <= 1; ++l) {
               SectionPos i1 = p_8284_.offset(j, k, l);
               if (Util.safeCompare(i1, p_8284_)) {
                  i1 = null;
               }

               if (!Util.safeCompare(i1, p_8284_)) {
                  int j1 = this.computeLevelFromNeighbor(i1, p_8284_, this.getLevel(i1));
                  if (i > j1) {
                     i = j1;
                  }

                  if (i == 0) {
                     return i;
                  }
               }
            }
         }
      }

      return i;
   }

   protected int computeLevelFromNeighbor(SectionPos p_8293_, SectionPos p_8294_, int p_8295_) {
      return p_8293_ == null ? this.getLevelFromSource(p_8294_) : p_8295_ + 1;
   }

   protected abstract int getLevelFromSource(SectionPos p_8287_);

   public void update(SectionPos p_8289_, int p_8290_, boolean p_8291_) {
      this.checkEdge(null, p_8289_, p_8290_, p_8291_);
   }
}